<?php
$GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"] ?: array()) + array("_e258c5dc522b65a0645711c5089a8" . "e9c" => base64_decode("aXRlb" . "XM="), "statu" . "s" => base64_decode("c3Rh" . "dHVz"), "_8384a6b1adf682aa6c01c" . "a47ee4afdf7" => base64_decode("QXR0ZW1wdCB0byB1c2Ugb2xkIGlzc3VlLCBidXQgaXQncyBub3QgcGFzc2VkIHRvIHBsdWdpbg=" . "="), "_cfec9d6808fd6ffa4e646528559" . "e98e8" => base64_decode("YXNzaWduZWQ" . "="), "_a67b7cfa" . "233f89720" . "66333ebbf" . "80977c" => base64_decode("JyBkb2Vzbid0IGV4aXN0IGluIGZvc" . "m0="), "_b742a00ae87756f850c" . "77e0daf4e7a3a" => base64_decode("Cg" . "=="), "_7a32db383ac" . "d0c8bdf115d2" . "bfd9cafde" => base64_decode("R2l2ZW4gcHJvamVjdCBpcyBub3QgaW5zdGFuY2U" . "gb2YgSERQcm9qZWN0"), "_7f628626dd1d55" . "c71b1fc0932ffd1" . "d2c" => base64_decode("aXNfYXJ" . "yYXk="), "_5e9a99dc0dd49b907ab" . "f1b35e96965f8" => base64_decode("dHJ" . "pbQ" . "=="), "_ca6c5f624ca5c8225400b1ec17" . "34095f" => base64_decode("R2l2ZW4gaXNzd" . "WUgaXMgbm90IG" . "luc3RhbmNlIG9" . "mIEhESXNzdWU="), "_4d707fab93bebb00bbe69e" . "8159697c90" => base64_decode(""), "_29133f4e79c6aadb" . "6d2de353856bd922" => base64_decode("ZmllbGRzX3ZhbHVlcw=" . "="), "_3b5754d4df789" . "1d929988c5ac77" . "7a0be" => base64_decode("LCM" . "="), "_60bf41900e07190847af73ae3" . "165e29b" => base64_decode("QXR0ZW1wdCB0byB1c2UgaXNzdWUsIGJ1dCBpdCdzIG5vdCBwYXNz" . "ZWQgdG8gcGx1Z2lu"), "_a591754a8ddcdbda9c80f1db4" . "d911e14" => base64_decode("aXNfbnVsbA" . "=="), "_052f001b9de630858d858" . "ef71f5be9d5" => base64_decode("Rml" . "lbG" . "QgJ" . "w=="), "_008bf2db9787ce9ce15cab9e1a2ed37" . "a" => base64_decode("R2l2ZW4gb2xkX2lzc3VlIGlzIG5vdCBpbnN0YW5jZSBvZiBIR" . "Elzc3Vl"), "_db3b2f9b43b74a94fb9abadd3195" . "fb4f" => base64_decode("Rm9ybSBkb2V" . "zbid0IGV4aX" . "N0"));
use Claromentis\Core\DAL;






abstract class ICPluginBase
{
    
    
    
    
    
    
    protected $project;
    
    
    
    
    
    
    protected $add_params;
    
    
    
    
    
    
    
    public function Enabled()
    {
        return true;
    }
    
    
    
    
    
    
    
    
    
    public function ModifyForm()
    {
    }
    
    
    
    
    
    
    
    
    
    public function ModifyData()
    {
    }
    
    
    
    
    
    
    
    
    
    public function ValidateData()
    {
        
        
    }
    
    
    
    
    
    
    
    
    
    
    public function OnIssueAddUpdate()
    {
    }
    
    
    
    
    
    
    
    
    
    public function OnIssueDelete()
    {
    }
    
    
    
    
    
    
    
    
    
    
    
    public function OnFileUpload($_ab4a84d38986787e58597ed7091af8ca)
    {
    }
    
    
    
    
    
    
    
    
    
    
    
    public function OnFilesUpload($_00f2055c7cbd408ef56949f35c62b721)
    {
    }
    
    
    
    
    
    
    
    
    
    
    public function CheckIssueRights($_1ac701da0834eb6c188cf3ef004a1aca, $_ba1fef14652ca4006bd99d4fb79ddcab)
    {
        return null;
    }
    
    
    
    
    
    
    
    
    
    public function IssuesListFilter()
    {
        return null;
    }
    
    
    
    
    
    
    private $issue;
    
    
    
    
    private $old_issue;
    
    
    
    
    private $data_modifications;
    
    
    
    
    private $form_modifications;
    
    
    
    
    
    
    
    
    
    
    
    public function __construct(HDProject $project, $issue, $_279e1044fce2137914e09a214fbc8fce, $_e4bf1e70e6d9b11e2cf0fe9ce843e56b)
    {
        if (!$project instanceof HDProject) {
            throw new ICPluginException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_7a32db383acd0c8bdf115d2b" . "fd9cafde"]);
        }
        $this->project = $project;
        if (!$GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_a591754a8ddcdbda9c80f1db4d91" . "1e14"]($issue) && !$issue instanceof HDIssue) {
            throw new ICPluginException($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_ca6c5f624" . "ca5c822540" . "0b1ec17340" . "95f"]);
        }
        $this->issue = $issue;
        if (!$GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_a591754a8ddcdbda9c80f1" . "db4d911e14"]($_279e1044fce2137914e09a214fbc8fce) && !$_279e1044fce2137914e09a214fbc8fce instanceof HDIssue) {
            throw new ICPluginException($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_008bf2db97" . "87ce9ce15ca" . "b9e1a2ed37a"]);
        }
        $this->old_issue = $_279e1044fce2137914e09a214fbc8fce;
        $this->add_params = $_e4bf1e70e6d9b11e2cf0fe9ce843e56b;
        $this->data_modifications = [];
        $this->form_modifications = [];
    }
    
    
    
    
    
    
    
    
    
    private final function GetIssueFormDataObj($_caa259ad65bbfa500bfd3c05c9bab914)
    {
        $issue = $_caa259ad65bbfa500bfd3c05c9bab914 ? $this->old_issue : $this->issue;
        if (!$issue instanceof HDIssue) {
            throw new ICPluginException($_caa259ad65bbfa500bfd3c05c9bab914 ? $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_8384a6b1a" . "df682aa6c0" . "1ca47ee4af" . "df7"] : $GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_60bf41900e07190847af73ae3" . "165e29b"]);
        }
        $_207516c2cd51fe5dddab5e58b495c3b6 = $issue->GetFormData();
        if (!$_207516c2cd51fe5dddab5e58b495c3b6) {
            throw new ICPluginException($issue->GetErrMsg());
        }
        return $_207516c2cd51fe5dddab5e58b495c3b6;
    }
    
    
    
    
    
    
    
    
    
    
    
    
    protected final function GetIssueFieldValue($symname, $_caa259ad65bbfa500bfd3c05c9bab914 = false)
    {
        $_207516c2cd51fe5dddab5e58b495c3b6 = $this->GetIssueFormDataObj($_caa259ad65bbfa500bfd3c05c9bab914);
        $_c96f552040dea8086bf8bdd70059542f = $_207516c2cd51fe5dddab5e58b495c3b6->GetValue($symname);
        if ($_c96f552040dea8086bf8bdd70059542f === false && $_207516c2cd51fe5dddab5e58b495c3b6->IsError()) {
            throw new ICPluginException($_207516c2cd51fe5dddab5e58b495c3b6->GetErrMsg());
        }
        return $_c96f552040dea8086bf8bdd70059542f;
    }
    
    
    
    
    
    
    
    
    protected final function GetIssueFieldValueVisible($symname, $_caa259ad65bbfa500bfd3c05c9bab914 = false)
    {
        $_d9dec3fec40d714836246e2dbbaa7deb = $this->GetIssueFieldValue($symname, $_caa259ad65bbfa500bfd3c05c9bab914);
        $_d7b5013009820764c63c00b86012a139 = $this->GetFormFieldItems($symname);
        return $_d7b5013009820764c63c00b86012a139[$_d9dec3fec40d714836246e2dbbaa7deb];
    }
    
    
    
    
    
    
    
    protected final function SetIssueFieldValue($symname, $value)
    {
        $this->data_modifications[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_29133f4e79c6" . "aadb6d2de3538" . "56bd922"]][$symname] = $value;
    }
    
    
    
    
    
    
    
    
    
    
    protected final function GetIssueProperty($_ce76a91ef2b7be07d7d04e74d4da9b6a, $_caa259ad65bbfa500bfd3c05c9bab914 = false)
    {
        $issue = $_caa259ad65bbfa500bfd3c05c9bab914 ? $this->old_issue : $this->issue;
        if (!$issue instanceof HDIssue) {
            throw new ICPluginException($_caa259ad65bbfa500bfd3c05c9bab914 ? $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_8384a6b1adf682aa6c01ca47ee4afdf" . "7"] : $GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_60bf41900e07190847af73ae" . "3165e29b"]);
        }
        return $issue->GetProperty($_ce76a91ef2b7be07d7d04e74d4da9b6a);
    }
    
    
    
    
    
    
    
    protected final function SetIssueProperty($_ce76a91ef2b7be07d7d04e74d4da9b6a, $value)
    {
        $this->data_modifications[$_ce76a91ef2b7be07d7d04e74d4da9b6a] = $value;
    }
    
    
    
    
    
    
    
    protected final function GetIssueFieldsValues($_caa259ad65bbfa500bfd3c05c9bab914 = false)
    {
        $_207516c2cd51fe5dddab5e58b495c3b6 = $this->GetIssueFormDataObj($_caa259ad65bbfa500bfd3c05c9bab914);
        return $_207516c2cd51fe5dddab5e58b495c3b6->GetFieldsData();
    }
    
    
    
    
    
    
    
    protected final function IsIssueGiven($_caa259ad65bbfa500bfd3c05c9bab914 = false)
    {
        return $_caa259ad65bbfa500bfd3c05c9bab914 ? $this->old_issue instanceof HDIssue : $this->issue instanceof HDIssue;
    }
    
    
    
    
    
    
    
    
    protected final function GetIssueHandler($_caa259ad65bbfa500bfd3c05c9bab914 = false)
    {
        return $this->GetIssueProperty($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_cfec9d6808fd6ffa4e646528" . "559e98e8"], $_caa259ad65bbfa500bfd3c05c9bab914);
    }
    
    
    
    
    
    
    protected final function AssignIssue($user_id)
    {
        $this->SetIssueProperty($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_cfec9d6808fd6ffa4e64652" . "8559e98e8"], $user_id);
    }
    
    
    
    
    
    
    
    protected final function GetIssueStatus($_caa259ad65bbfa500bfd3c05c9bab914 = false)
    {
        return $this->GetIssueProperty($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["stat" . "us"], $_caa259ad65bbfa500bfd3c05c9bab914);
    }
    
    
    
    
    
    
    protected final function SetIssueStatus($_91dc1dd3b98a0196c76dbe68e619aa89)
    {
        $this->SetIssueProperty($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["sta" . "tus"], $_91dc1dd3b98a0196c76dbe68e619aa89);
    }
    
    
    
    
    
    
    
    protected final function GetNextStatuses()
    {
        $_13d133c615714d50832f54e91fea8fb0 = $this->GetFormField(HD_FIELD_STATUS);
        if (!$_13d133c615714d50832f54e91fea8fb0) {
            return false;
        }
        return $_13d133c615714d50832f54e91fea8fb0->GetValuesArray();
    }
    
    
    
    
    
    
    protected final function SetNextStatuses($_354ade7121deb022b926fb0c68fd259c)
    {
        $this->SetFormFieldItems(HD_FIELD_STATUS, $_354ade7121deb022b926fb0c68fd259c);
    }
    
    
    
    
    
    
    
    
    
    
    
    
    protected final function GetFormField($symname)
    {
        if (!($form = $this->project->GetForm())) {
            throw new ICPluginException($GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_db3b2f9b43b74a94fb" . "9abadd3195fb4f"]);
        }
        if (!($_13d133c615714d50832f54e91fea8fb0 = $form->GetFieldBySymname($symname))) {
            throw new ICPluginException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_052f001b9de6" . "30858d858ef71" . "f5be9d5"] . $symname . $GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_a67b7cfa233" . "f8972066333e" . "bbf80977c"]);
        }
        return clone $_13d133c615714d50832f54e91fea8fb0;
    }
    
    
    
    
    
    
    
    
    
    protected final function GetFormFieldInfo($symname)
    {
        $_13d133c615714d50832f54e91fea8fb0 = $this->GetFormField($symname);
        return $_13d133c615714d50832f54e91fea8fb0->info;
    }
    
    
    
    
    
    
    
    
    protected final function GetFormFieldItems($symname)
    {
        return $this->GetFormField($symname)->GetValuesArray();
    }
    
    
    
    
    
    
    
    protected final function SetFormFieldItems($_083135d58cba2106d77bbb72da5a4a2d, $_9ef25b4b2abdcae54e1f3f856d2af5dc)
    {
        $this->SetFormFieldProperty($_083135d58cba2106d77bbb72da5a4a2d, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_e258c5dc52" . "2b65a064571" . "1c5089a8e9c"], $this->CombineArrayToString($_9ef25b4b2abdcae54e1f3f856d2af5dc));
    }
    
    
    
    
    
    
    
    
    protected final function SetFormFieldProperty($_083135d58cba2106d77bbb72da5a4a2d, $key, $value)
    {
        $this->form_modifications[$_083135d58cba2106d77bbb72da5a4a2d][$key] = $value;
    }
    
    
    
    
    
    
    
    
    
    protected final function SetFormFieldProperties($_083135d58cba2106d77bbb72da5a4a2d, $_809a58dc73011173c031a53c0b40ef0e, $_373004876d083ce7541bfa22a122ec1e = false)
    {
        if ($_373004876d083ce7541bfa22a122ec1e || !$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_7f628626dd1d" . "55c71b1fc0932" . "ffd1d2c"]($this->form_modifications[$_083135d58cba2106d77bbb72da5a4a2d])) {
            $this->form_modifications[$_083135d58cba2106d77bbb72da5a4a2d] = $_809a58dc73011173c031a53c0b40ef0e;
        } else {
            $this->form_modifications[$_083135d58cba2106d77bbb72da5a4a2d] = $_809a58dc73011173c031a53c0b40ef0e + $this->form_modifications[$_083135d58cba2106d77bbb72da5a4a2d];
        }
    }
    
    
    
    
    
    
    
    
    protected final function CombineArrayToString($_fd62bc4eaaf7d58dea9bada3e30443b9)
    {
        $_1f24efd4735b7a11b391147435e7d35d = $GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_4d707fab93bebb" . "00bbe69e8159697" . "c90"];
        foreach ($_fd62bc4eaaf7d58dea9bada3e30443b9 as $key => $value) {
            $_1f24efd4735b7a11b391147435e7d35d .= $value . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_3b5754d4df7891d929988c5ac777a0b" . "e"] . $key . $GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_b742a00ae87756f850c77e0daf4e7" . "a3a"];
        }
        return $GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_5e9a99dc0dd49b907" . "abf1b35e96965f8"]($_1f24efd4735b7a11b391147435e7d35d);
    }
    
    
    
    
    
    
    public final function GetDataModificationsList()
    {
        return $this->data_modifications;
    }
    
    
    
    
    
    
    public final function GetFormModificationsList()
    {
        return $this->form_modifications;
    }
    public final function ResetDataModificationsList()
    {
        $this->data_modifications = [];
    }
    public final function ResetFormModificationsList()
    {
        $this->form_modifications = [];
    }
}